
import ij.*;
import ij.gui.*;
import ij.measure.*;
import ij.plugin.*;
import ij.plugin.filter.*;
import ij.plugin.frame.*;
import ij.process.*;
import ij.util.*;
import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
import java.lang.*;
import java.io.FileWriter;
import java.io.*;
import java.util.StringTokenizer;
import java.text.*;



  public class DivisonMap8Bit implements PlugIn {

    private ImageWindow distIw;
    private ImageWindow onIw;
    private ImageWindow offIw;
    private ImageWindow wayOffIw;
    private ImageWindow diffIw;
    private ImageWindow divIw;
    private boolean invert = false;

      NumberFormat formatter = NumberFormat.getNumberInstance();

    public void run (String arg) {
      	formatter.setMaximumFractionDigits(1);
		  formatter.setMinimumFractionDigits(1); }
		
      public void divisonMap(double onPeakEnergyDbl, double offPeakEnergyDbl, double startEnergyDbl, 
      							  double stepEnergyDbl, double endEnergyDbl, ImageStack stack, ImagePlus imp, boolean inverting,
      							  int onPeakSlice, int offPeakSlice) { 
      
        byte[] onPeakArray;
        byte[] offPeakArray;
        byte[] distributionArray;
        byte[] differenceArray;
        float[] divArray;
        
			invert = inverting;
        if (onPeakEnergyDbl == -1.0 || offPeakEnergyDbl == -1.0 ) {
            IJ.showMessage("Spectrum Extractor_ Error",
            "You must enter valid numbers for the Peak Information");
            return;
        }

        if ((onPeakEnergyDbl > startEnergyDbl) ||
            (offPeakEnergyDbl > startEnergyDbl) ||
            (onPeakEnergyDbl < endEnergyDbl) ||
            (offPeakEnergyDbl < endEnergyDbl) ) {
            IJ.showMessage("Spectrum Extrator Error",
                   "Peak energies must be between the start and stop energy!");
            return;
        }
       

       	SaveInputs(onPeakEnergyDbl, offPeakEnergyDbl, startEnergyDbl, stepEnergyDbl);
           
			GenericDialog gd1 = new GenericDialog("Number of On Peak Slices to Avg");
			gd1.addNumericField("On Peak Slices to Avg:", 3,0);
			gd1.addMessage("Number must be odd!");
			gd1.showDialog();
			if (gd1.wasCanceled()) {
		  	IJ.error("PlugIn canceled!");
		  	return;
			}
		
			int onPeakAvgInt = (int) gd1.getNextNumber();
		
			GenericDialog gd2 = new GenericDialog("Number of Off Peak Slices to Avg");
			gd2.addNumericField("Off Peak Slices to Avg:", 3,0);
			gd2.addMessage("Number must be odd!");
			gd2.showDialog();
			if (gd2.wasCanceled()) {
		  	IJ.error("Dialog box canceled");
		  	return;
			}
		
			int offPeakAvgInt = (int) gd2.getNextNumber();
			
			
			if(offPeakAvgInt == 1 && onPeakAvgInt == 1)
			
			{	
				onPeakArray = (byte[])stack.getPixels(onPeakSlice);
				offPeakArray = (byte[])stack.getPixels(offPeakSlice);
         }
         
         
         else
         {

        		getAverage8Bit PeakAvg = new getAverage8Bit();
		
		  		onPeakArray = PeakAvg.getAverage(onPeakSlice, stack, imp, onPeakAvgInt);
        		offPeakArray = PeakAvg.getAverage(offPeakSlice, stack, imp, offPeakAvgInt);
        }
	
		
        differenceArray = new byte[imp.getWidth() * imp.getHeight()];
 
        for (int i = 0; i < (imp.getWidth() * imp.getHeight()); i++){
            if ((onPeakArray[i] - offPeakArray[i]) > 0) {
                differenceArray[i] = (byte)(onPeakArray[i] - offPeakArray[i]);
            } else {
                differenceArray[i] = 0;
            }
        }
        

        divArray = new float[imp.getWidth() * imp.getHeight()];
        double[] divArray2 = new double[imp.getWidth() * imp.getHeight()];
        
        double[] tempArray = new double[imp.getWidth() * imp.getHeight()]; 
        double tempDouble = 0.0;
        
        double[] tempArray2 = new double[imp.getWidth() * imp.getHeight()]; 
        
        for (int i=0; i< (imp.getWidth() * imp.getHeight()); i++)
        
        {
        		tempArray[i] = 255-((double)(onPeakArray[i] & 0xff));
        		tempArray2[i] = 255-((double)(offPeakArray[i] & 0xff));
        }
        
        for (int i=0; i< (imp.getWidth() * imp.getHeight()); i++)
        
        {
        		tempArray[i] = 1.0+tempArray[i];
        		tempArray2[i] = 1.0+tempArray2[i];
        }
        
       for (int i=0; i< (imp.getWidth() * imp.getHeight()); i++)
        
        {
        		divArray2[i] = (tempArray2[i] / tempArray[i]);
        		divArray[i] = (float) (divArray2[i]);
        }
        /*
        for (int i = 0; i < (imp.getWidth() * imp.getHeight()); i++)
          {
        	 
        		 tempArray[i] = ((((double)(onPeakArray[i] & 0xff )) / ((double)(offPeakArray[i] & 0xff)))*100);      		  
             if( (tempArray[i] > tempDouble) && (tempArray[i] < 256) )
           	 tempDouble = tempArray[i];
           }	
        
        
        if (invert)
        		{
        			for (int i = 0; i < (imp.getWidth() * imp.getHeight()); i++){
        		 
        				divArray2[i] = ((((double)(onPeakArray[i] & 0xff )) / ((double)(offPeakArray[i] & 0xff)))*(255.0/tempDouble));      		  
            		divArray[i] = (byte)((255 - (int)divArray2[i])& 0xff) ;
        			}
        
        
        		}
        		
        else {
        		for (int i = 0; i < (imp.getWidth() * imp.getHeight()); i++){
        		 
        				divArray2[i] = ((((double)(onPeakArray[i] & 0xff )) / ((double)(offPeakArray[i] & 0xff)))*100);      		  
            		divArray[i] = (byte)(divArray2[i]);
        			}
        		}

       
       */

        /*if (!displayPeaksCB.getState()) {
            ImagePlus onImp = NewImage.createShortImage("On_Peak_Ave_Slice#" + onPeakSlice + "_Ev_" + onPeakEnergyDbl,
                    imp.getWidth(), imp.getHeight(), 1, 0);
            ImageProcessor onIp = onImp.getProcessor();
            onIp.setPixels(onPeakArray);
            onIp.resetMinAndMax();
            onIw = new ImageWindow(onImp);
            onImp.updateAndDraw();
            onImp.show();
            onImp.updateAndRepaintWindow();

            ImagePlus offImp = NewImage.createShortImage("Off_Peak_Ave_Slice#" + offPeakSlice + "_Ev_" + offPeakEnergyDbl,
                    imp.getWidth(), imp.getHeight(), 1, 0);
            ImageProcessor offIp = offImp.getProcessor();
            offIp.setPixels(offPeakArray);
            offIp.resetMinAndMax();
            offIw = new ImageWindow(offImp);
            offImp.updateAndDraw();
            offImp.show();

            ImagePlus wayOffImp = NewImage.createShortImage("Way_Off_Peak_Ave_Slice#" + wayOffPeakSlice + "_Ev_" + wayOffPeakEnergyDbl,
                    imp.getWidth(), imp.getHeight(), 1, 0);
            ImageProcessor wayOffIp = wayOffImp.getProcessor();
            wayOffIp.setPixels(wayOffPeakArray);
            wayOffIp.resetMinAndMax();
            wayOffIw = new ImageWindow(wayOffImp);
            wayOffImp.updateAndDraw();
            wayOffImp.show();
        }
        ImagePlus distImp = NewImage.createShortImage("Distribution_Map_" + onPeakEnergyDbl + "_" + offPeakEnergyDbl + "_" + wayOffPeakEnergyDbl,
                imp.getWidth(), imp.getHeight(), 1, 0);
        ImageProcessor distIp = distImp.getProcessor();
        distIp.setPixels(distributionArray);
        distIp.resetMinAndMax();
        distIw = new ImageWindow(distImp);
        distImp.updateAndDraw();
        distImp.show();

        ImagePlus diffImp = NewImage.createShortImage("Difference Map" + onPeakEnergyDbl + "_" + offPeakEnergyDbl,
                imp.getWidth(), imp.getHeight(), 1, 0);
        ImageProcessor diffIp = diffImp.getProcessor();
        diffIp.setPixels(differenceArray);
        diffIp.resetMinAndMax();
        diffIw = new ImageWindow(diffImp);
        diffImp.updateAndDraw();
        diffImp.show();
        */
        ImagePlus divImp = NewImage.createFloatImage("Division Map" + onPeakEnergyDbl + "_" + offPeakEnergyDbl,
                imp.getWidth(), imp.getHeight(), 1, 0);
        ImageProcessor divIp = divImp.getProcessor();
        divIp.setPixels(divArray);
        divIp.resetMinAndMax();
        divIw = new ImageWindow(divImp);
        divImp.updateAndDraw();
        divImp.show();
        IJ.run("8-bit");
        //IJ.run("Enhance Contrast", "saturated=0.5 equalize");

    } 

  public void SaveInputs (double onPeakEnergyDbl2, double offPeakEnergyDbl2, double startEnergyDbl2,  double stepEnergyDbl2) {
    saveInputs endingEnergies = new saveInputs();
    endingEnergies.saveInputs(onPeakEnergyDbl2, offPeakEnergyDbl2, startEnergyDbl2,  stepEnergyDbl2);
  }
  
  public ImageWindow returnWin (){
  		return divIw;
  		}
    
}    