import ij.*;
import ij.gui.*;
import ij.measure.*;
import ij.plugin.*;
import ij.plugin.filter.*;
import ij.plugin.frame.*;
import ij.process.*;
import ij.util.*;
import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
import java.lang.*;
import java.io.FileWriter;
import java.io.*;
import java.util.StringTokenizer;
import java.text.*;
import java.util.*;
import ij.process.*;
import ij.util.Java2;
import java.util.Stack;
import ij.text.TextWindow;


public class ROIManager implements PlugIn{
	
	private int roiCounter = 1;
   private Hashtable rois = new Hashtable();
   private Stack roiStack = new Stack();
   private ExtractSpectrum extractor = new ExtractSpectrum();
   private Roi newRoi;
   private ImageStack stack;
   private double startEnergyDbl = 0;
   private double stepEnergyDbl = 0;
   private double endEnergyDbl = 0;
   private ImagePlus imp;
   private ImagePlus roiImp;
   private ImageWindow roiIw;
   
	
	public void run(String arg) {}

	public void roiManager(ImagePlus imp2, double startEnergyDbl2, double stepEnergyDbl2)
  		{
  			imp = imp2;
  			startEnergyDbl = startEnergyDbl2;
			stepEnergyDbl = stepEnergyDbl2;
  			
  			if (roiCounter == 1)
  			{ 
  				//IJ.run("New...", "name=Regions_of_Interest type=8-bit fill=White width=640 height=512 slices=1");	
				newRoi=imp.getRoi();
				
				roiImp = NewImage.createByteImage("Regions_of_Interest " + imp.getTitle(),imp.getWidth(), imp.getHeight(), 1, 0);
				roiIw = new ImageWindow(roiImp);
        		roiImp.updateAndDraw();
        		roiImp.show();
            IJ.selectWindow("Regions_of_Interest " + imp.getTitle());
				roiImp.setRoi(newRoi);
				IJ.run("Draw");
				String roiString = "" + roiCounter;
				Rectangle r = newRoi.getBoundingRect();
				ImageProcessor ip = roiImp.getProcessor();
				ip.drawString(roiString, r.x, r.y-5);
				roiStack.push(newRoi);
				//rois.put(roiString, newRoi.clone());
				roiCounter++;
  			}
  			
  			else
  			{	
  				IJ.selectWindow("Regions_of_Interest " + imp.getTitle());
  				newRoi = imp.getRoi();
  				roiImp = WindowManager.getCurrentImage();
				roiImp.setRoi(newRoi);
				IJ.run("Draw");
				String roiString = "" + roiCounter;
				Rectangle r = newRoi.getBoundingRect();
				ImageProcessor ip = roiImp.getProcessor();
				ip.drawString(roiString, r.x, r.y-5);
				roiStack.push(newRoi);
				//rois.put(roiString, newRoi.clone());
				roiCounter++;
  			}
  			
  		}
  		
  		String d2s(float n) {
		if (Math.round(n)==n)
			return(IJ.d2s(n,0));
		else
			return(IJ.d2s(n));
	}
	
	public void extractAllSpectrum(double endEnergyDbl2, ImageStack stack2) 
		{
			endEnergyDbl = endEnergyDbl2;
			stack = stack2;
  			
  			String headings = "Energy";
  			StringBuffer energy = new StringBuffer();
  			StringBuffer roiValue = new StringBuffer();
  			
  			float[] x = extractor.xAxisData(startEnergyDbl, stepEnergyDbl, endEnergyDbl, stack);
  			float[][] y = new float[roiCounter-1][x.length];
  			float[] tempY = new float[x.length];
  			
  			for(int i = (roiCounter-1); i >= 1; i--)
  			{
  				String roiString = "" + i;
  				//newRoi = (Roi)rois.get(roiString);
  				newRoi = (Roi)roiStack.pop();
  				imp.setRoi(newRoi);

            tempY = extractor.yAxisData(startEnergyDbl, stepEnergyDbl, 
            	endEnergyDbl, stack, imp, newRoi);
            
            if(imp.getType() == 1)
            {
            
            	for (int j=0; j<x.length; j++)
            	{
            		y[i-1][j] = tempY[j]-32768;
            	}
            
            }
            else
            {
            	for (int j=0; j<x.length; j++)
            	{
            		y[i-1][j] = tempY[j];
            	}
            
            }
            
            }

         for(int i=0; i<x.length; i++)
  			{
  				energy.append("" + d2s(x[i]));
  				
  				for (int j=roiCounter-1; j>=1; j--)
  				{
  					energy.append("" + "\t"+ d2s(y[j-1][i]));
				}
				energy.append("\n");
				
  			}  
  			
  			 for (int j = roiCounter - 1; j>=1; j--)
  			 headings += ("\t" + "roi " + j);
  			 
				TextWindow tw = new TextWindow("Spectrum Values " + imp.getTitle() , headings, energy.toString(), 200, 400);

				IJ.selectWindow("Spectrum Values " + imp.getTitle());
				roiCounter =1;
			}
			
	public void extractAllSpectrum(double endEnergyDbl2, ImageStack stack2, double[] energies) 
		{
			endEnergyDbl = endEnergyDbl2;
			stack = stack2;
  			
  			String headings = "Energy";
  			StringBuffer energy = new StringBuffer();
  			StringBuffer roiValue = new StringBuffer();
  			
  			float[] x = extractor.xAxisData(startEnergyDbl, stepEnergyDbl, endEnergyDbl, stack, energies);
  			float[][] y = new float[roiCounter-1][x.length];
  			float[] tempY = new float[x.length];
  			
  			for(int i = (roiCounter-1); i >= 1; i--)
  			{
  				String roiString = "" + i;
  				//newRoi = (Roi)rois.get(roiString);
  				newRoi = (Roi)roiStack.pop();
  				imp.setRoi(newRoi);

            tempY = extractor.yAxisData(startEnergyDbl, stepEnergyDbl, 
            	endEnergyDbl, stack, imp, newRoi);
            
            if(imp.getType() == 1)
            {
            
            	for (int j=0; j<x.length; j++)
            	{
            		y[i-1][j] = tempY[j]-32768;
            	}
            
            }
            else
            {
            	for (int j=0; j<x.length; j++)
            	{
            		y[i-1][j] = tempY[j];
            	}
            
            }
            
            }

         for(int i=0; i<x.length; i++)
  			{
  				energy.append("" + d2s(x[i]));
  				
  				for (int j=roiCounter-1; j>=1; j--)
  				{
  					energy.append("" + "\t"+ d2s(y[j-1][i]));
				}
				energy.append("\n");
				
  			}  
  			
  			 for (int j = roiCounter - 1; j>=1; j--)
  			 headings += ("\t" + "roi " + j);
  			 
				TextWindow tw = new TextWindow("Spectrum Values " + imp.getTitle() , headings, energy.toString(), 200, 400);

				IJ.selectWindow("Spectrum Values " + imp.getTitle());
				roiCounter =1;
			}
			
	}